<template>

<p>Resposta do Websocket:</p>
  <pre>
      {{state.websocket.response}}
  </pre>

  <hr />
  <p>Envia para Websocket:</p>
  <form>
    <input type="number" v-model="state.form.time" placeholder="Waiting time">
    <input type="text" v-model="state.form.channel" placeholder="Channel name">
    <input type="text" v-model="state.form.message">
    <button @click.prevent="sendMessage()">Enviar</button>
  </form>

<pre>{{state.form}}</pre>
</template>

<script>
import { reactive } from '@vue/reactivity'
import { io } from "socket.io-client"
const socket = io('http://localhost:3000')

export default {

  setup() {
    const state = reactive({
      form: {
        time: 0,
        channel: 1,
        message: 'WebSocket'
      },
      websocket: {
        response: null
      }
    })

    const sendMessage = () => {
      receiveMessage(state.form.channel)
      socket.emit('default_channel', state.form)
    }

    const receiveMessage = (channel) => {
      socket.on(channel, function(payload) {
          state.websocket.response = payload
          console.log(payload)
      })
    }

    return {
      state,
      io,
      sendMessage,
      receiveMessage
    }
  }

}
</script>

<style scoped>
  form * {
    padding: 5px;
  }
</style>
